require 'ray_shader'

function love.load()
 pixeleffect = love.graphics.newPixelEffect(raytracer_shader)

 width = love.graphics.getWidth()
 height= love.graphics.getHeight()
 aspect= width/height

 time  = 0

 rotx  = 0
 roty  = 0
 rotz  = 0

 posx = 0;
 posy = 0;
 posz = 0;

 lookx= 0;
 looky= 0;
 lookz= 0;

 love.mouse.setVisible(false)
 lmposx= width/2
end

function cameraupdate(dt)
 local rx = math.cos(rotx) * math.sin(roty)
 local ry = math.sin(rotx)
 local rz = math.cos(rotx) * math.cos(roty)

 local sx = math.sin(roty - math.pi/2)
 local sy = 0
 local sz = math.cos(roty - math.pi/2)


 if(love.keyboard.isDown("w") == true) then
  posx = posx + rx*dt
  posz = posz + rz*dt
 elseif(love.keyboard.isDown("s") == true) then
  posx = posx - rx*dt
  posz = posz - rz*dt
 end

 if(love.keyboard.isDown("a") == true) then
  posx = posx + sx*dt
  posz = posz + sz*dt
 elseif(love.keyboard.isDown("d") == true) then
  posx = posx - sx*dt
  posz = posz - sz*dt
 end

 if(love.keyboard.isDown("b") == true) then
  posy = posy + 1*dt
 elseif(love.keyboard.isDown("n") == true) then
  posy = posy - 1*dt
 end
 roty = roty + ((love.mouse.getX() - width/2))/width   -- x

 lookx = posx + rx
 looky = posy + ry
 lookz = posz + rz

 love.mouse.setPosition( width/2, height/2 )
end

function love.update(dt)
 time = time + dt
 cameraupdate(dt)

 pixeleffect:send("camera.position",{posx ,posy ,posz  });
 pixeleffect:send("camera.lookat"  ,{lookx,looky,lookz });

 pixeleffect:send("sphere[0].position"  ,{0.4 ,0.2 ,4.3 });
 pixeleffect:send("sphere[0].color"     ,{1,0,0,1 });
 pixeleffect:send("sphere[0].specular"  ,{0.2,0.2,0.2,0.2 });
 pixeleffect:send("sphere[0].radius"    ,{0.3});
 pixeleffect:send("sphere[0].reflection",{0.0});

 pixeleffect:send("sphere[1].position"  ,{-0.5 ,0.2 ,4 });
 pixeleffect:send("sphere[1].color"     ,{0,0,1,1 });
 pixeleffect:send("sphere[1].specular"  ,{0.2,0.2,0.2,0.2});
 pixeleffect:send("sphere[1].radius"    ,{0.3});
 pixeleffect:send("sphere[1].reflection",{0.0});

 pixeleffect:send("sphere[2].position"  ,{-0.3 ,0.2 ,4.6 });
 pixeleffect:send("sphere[2].color"     ,{0,1,0,1 });
 pixeleffect:send("sphere[2].specular"  ,{0.2,0.2,0.2,0.2});
 pixeleffect:send("sphere[2].radius"    ,{0.3});
 pixeleffect:send("sphere[2].reflection",{0.0});
 pixeleffect:send("sphere[2].fresnelstr",{2.5});

 pixeleffect:send("sphere[3].position"  ,{-0.1 +math.sin(time/10) ,0.2 ,3.4 });
 pixeleffect:send("sphere[3].color"     ,{1,1,0,1 });
 pixeleffect:send("sphere[3].specular"  ,{0.2,0.2,0.2,0.2});
 pixeleffect:send("sphere[3].radius"    ,{0.3});
 pixeleffect:send("sphere[3].reflection",{1.0});
 pixeleffect:send("sphere[3].fresnelstr",{1.0});

 pixeleffect:send("light.position" ,{0.3 + math.sin(time)*2 ,-0.5 ,2 });
 pixeleffect:send("light.direction",{0,-1,-1});
 --pixeleffect:send("light.color"   ,{1,1,1,1 });
 pixeleffect:send("light.strenght",{0.8});


 if(love.keyboard.isDown("escape") == true) then
  love.event.quit()
 end
end

function love.draw()
 love.graphics.setPixelEffect(pixeleffect)
 love.graphics.rectangle('fill', 0,0,width,height)
end
